package com.example.aplicativo;

import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.util.SparseBooleanArray;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
/*
 * classe responsavel por customizar a lista do Painel Mensagem
 * Atravez desta classe  possivel selecionar e remover um item da lista
 */
		
public class CustomListViewAdapter extends ArrayAdapter<RowItem> 
{
	
	Context context;
	private SparseBooleanArray mSelectedItemsIds;
	public CustomListViewAdapter(Context context, int resourceid, List<RowItem> items) 
	{
	
		super(context, resourceid, items);
		mSelectedItemsIds = new SparseBooleanArray();
		this.context = context;
	}

	private class ViewHolder
	{
		TextView txtNome;
		TextView txtQnt;
	}
	
	public View getView(int position, View convertView, ViewGroup parent)
	{
	
		ViewHolder holder = null;
		RowItem rowItem = getItem(position);
		LayoutInflater mInflater = (LayoutInflater) context.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
		
		if(convertView == null)
		{
			convertView = mInflater.inflate(R.layout.list_item, null);
			holder = new ViewHolder();
			holder.txtNome = (TextView) convertView.findViewById(R.id.list_row_name);
			holder.txtQnt = (TextView) convertView.findViewById(R.id.list_row_qnt);
			convertView.setTag(holder);
		}
		else
		{
			holder = (ViewHolder) convertView.getTag();
		}
		
		holder.txtNome.setText(rowItem.getNome());
		holder.txtQnt.setText(rowItem.getQnt());
		return convertView;
		
	}
	
	public void toggleSelection(int position)
	{
		selectView(position, !mSelectedItemsIds.get(position));
	}
	 
	public void selectView(int position, boolean value) 
	{
		
		if (value)
			mSelectedItemsIds.put(position, value);
		
		else
			mSelectedItemsIds.delete(position);
		
		notifyDataSetChanged();
	}
	
	public void removeSelection() 
	{
		mSelectedItemsIds = new SparseBooleanArray();
		notifyDataSetChanged();
	}
	
	public SparseBooleanArray getSelectedIds() 
	{
		return mSelectedItemsIds;
	}
}

