package com.example.aplicativo;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class Informacoes_Usuario_Selecionado extends Activity 
{
	
	private String nomeUsuario;
	private String meunome;
	private int MeuId;
	private int UserId;
	
	String Id_marcador;
	String Distancia;
	String Status;//habilita o usuario para estar sendo mostrado no mapa
	String Cidade;//cidade do usuario
	String Idioma;//idiomas que o usuario tem conhecimento
	String Email;//email do usuario
	String Data;//ultima data que o usuario logou no sistema
	
	private TextView userDistanciaView;
	private TextView userLocationView;
	private TextView userLanguageView;
	private TextView userNameView1;
	private TextView userEmailView;
	private TextView userNameView;
	private TextView userDateView;	
	ProgressDialog dialog;
	Button btChat_usuario;

	@Override
	protected void onCreate(final Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.informacoes_usuario_selecionado);
		Inicializa();
	}
	
	private void Inicializa()
	{
		dialog = ProgressDialog.show(Informacoes_Usuario_Selecionado.this, "Processando...", "Carregando Informaes, Por Favor Aguarde...");
	
		if (VerificaConexao(Informacoes_Usuario_Selecionado.this))
		{
			RecebeDados();
			FindViews();
			linkView();
			GlobalClass globalVariable = (GlobalClass) getApplicationContext();
			globalVariable.setGlobal(0);
			add_inf(nomeUsuario, Idioma, Email, Cidade, Distancia, Data);
		
		} 
		else 
		{  
			dialog.dismiss();//finaliza o dialog "mensagem de carregando"
    		ToastMake("Sem conexo com a internet.");
		}
		
	}
	/*
	 * Recebe os dados da classe anterior e atribui os valores em suas respectivas variaveis para serem utilizadas
	 */
	
	public void RecebeDados()
	{//recebe o valor da barra de progresso 
    	Intent intent = getIntent();
    	
    	if(intent != null)
    	{
    		Bundle extras = intent.getExtras();
    		
    		if(extras != null)
    		{
    			UserId = Integer.parseInt(extras.getString("Id"));
    			Id_marcador = extras.getString("Id_marcador");
    			nomeUsuario = extras.getString("NomeUser");
    			Distancia = extras.getString("Distancia");
    			meunome = extras.getString("MeuNome");
    			Idioma = extras.getString("Idioma");
    			Cidade = extras.getString("Cidade");
    			Status = extras.getString("Status");
    			Email = extras.getString("Email");
    			Data = extras.getString("Data");
    			MeuId = extras.getInt("MeuID");
    		}
    	}
    }

	private void FindViews()
	{
		userDistanciaView = (TextView) findViewById(R.id.informacao_usuario_TxtDistancia);
		userDateView = (TextView) findViewById(R.id.informacao_usuario_TxtDataOnline);
		userLocationView = (TextView) findViewById(R.id.informacao_tv_Usu_Cidade);
		userLanguageView = (TextView) findViewById(R.id.informacao_tv_Usu_Idioma);
		userEmailView = (TextView) findViewById(R.id.informacao_tv_Usu_Email);
		userNameView1 = (TextView) findViewById(R.id.Informacao_tv_Nome1);
		userNameView = (TextView) findViewById(R.id.informacao_tv_Nome);
	}
	
	private void linkView()
	{		
		btChat_usuario = (Button) findViewById(R.id.informacao_btMapa);
    	btChat_usuario.setOnClickListener(click_btChat);
	}
	
	/*
	 * OnClick
	 */
	OnClickListener click_btChat = new OnClickListener() 
	{	
		
		@Override
		public void onClick(View v) 
		{
		
			if (VerificaConexao(Informacoes_Usuario_Selecionado.this)) 
			{  
				/*
				 * envio algumas informaes que sera necessaria na proxima classe
				 */
				Bundle extras = new Bundle();
				extras.putString("Nome",nomeUsuario);
				extras.putString("MeuNome", meunome);
				extras.putInt("UserID", UserId);
				extras.putInt("MeuID",MeuId);	
				Intent TelaChat = new Intent(getApplicationContext(),Tela_de_chat_do_usuario.class);
				TelaChat.putExtras(extras);//envia o parametro
				startActivity(TelaChat);
            }
			else 
			{  
            	ToastMake("Sem conexo com a internet.");
            }
		}
	};
	
	/*
	 * Adiciono as informaes recebidas nos itens da tela
	 */
	public void add_inf(String Nome_banco, String Idioma_banco, String email, String cidade, String distancia, String Date)
	{	
		userDistanciaView.setText(distancia+" m");
		userLanguageView.setText(Idioma_banco);
		userNameView1.setText(Nome_banco);
		userNameView.setText(Nome_banco);			
		userLocationView.setText(cidade);
		userEmailView.setText(email);
		userDateView.setText(Date);
		dialog.dismiss();//finaliza o dialog "mensagem de carregando"
	}
	
	/* 
	 * Faz a verificaao se o SmartPhone est conectado a internet, caso esteja retorna verdadeiro, o usuario
	 * conseguira ter acesso a informaes do aplicativo, se no houver conexo uma mensagem de erro seja 
	 * apresentado ao usuario informando a falta de conectividade
	 */
	public boolean VerificaConexao(Context classe) 
	{  
        //Pego a conectividade do contexto passado como argumento  
        ConnectivityManager gerenciador = (ConnectivityManager) classe.getSystemService(Context.CONNECTIVITY_SERVICE);  
        //Crio a varivel informacao que recebe as informaes da Rede  
        NetworkInfo informacao = gerenciador.getActiveNetworkInfo();  
        //Se o objeto for nulo ou nao tem conectividade retorna false  
        
        if ((informacao != null) && (informacao.isConnectedOrConnecting()) && (informacao.isAvailable())) 
        {  
        	return true; 
        }  
        
        return false;  
    }  
	/*
	 * procedimento para mostrar uma janela com uma determinada mensagem
	 */
	public void ToastMake(String Msg)
	{
		Toast.makeText(this,Msg,Toast.LENGTH_SHORT).show();
	}

	public void onBackPressed() 
	{
		 finish();
	}
}