package com.example.aplicativo;


import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.content.pm.Signature;

import com.parse.LogInCallback;
import com.parse.Parse;
import com.parse.ParseException;
import com.parse.ParseFacebookUtils;
import com.parse.ParseUser;
import com.example.aplicativo.R;
import com.facebook.Session;

import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.util.Base64;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class MainActivity extends Activity 
{

	private Button loginButton;
	private Dialog progressDialog;
		
	public void Inicializa()
	{
		setContentView(R.layout.activity_main);//tela principal
		
	}
	/*
	 * procedimento responsavel para obter a chave Hash
	 */
	public void KeyHash()
	{
		try 
		{
            PackageInfo info = getPackageManager().getPackageInfo("com.example.aplicativo", PackageManager.GET_SIGNATURES);
        
            for (Signature signature : info.signatures) 
            {
                MessageDigest md = MessageDigest.getInstance("SHA");
                md.update(signature.toByteArray());
                Log.d("KeyHash:", Base64.encodeToString(md.digest(), Base64.DEFAULT));
            }
        } 
		catch (NameNotFoundException e) {

        }
		catch (NoSuchAlgorithmException e) {

        }
	}
	
    @Override
    protected void onCreate(final Bundle savedInstanceState) 
    {	
        super.onCreate(savedInstanceState);
        Inicializa();//faz a chama da tela principal do aplicativo
        linkView();
    }   
    
    @Override
	public void onPause()
    {
		super.onPause();
	}
    
    public void onResume()
    {
		super.onResume();
	}
    
    @Override
	public void onDestroy()
    {
		super.onDestroy();
		System.out.println("DESTROY MAIN");
		finish();
	}
    
    /* Botoes*/
    private void linkView()
    {    	
    	loginButton = (Button) findViewById(R.id.loginButton);
    	loginButton.setOnClickListener(click_btFacebook);
    	
    	/*
    	 Os procedimentos abaixo inicializa a aplicao do facebook, e verifica se esta cadastrado no APP site, atraves
    	 de ID e Key, caso seja invalida no sera possivel utilizar o facebook como login
    	 Faz a verificao se o usuario ja logou no facebook utilizando o Aplicativo ou FACEBOOK.
    	 caso ja tenha logado chama a ShowUserDetailsActivity, ou seja chama o Painel de opes. 
    	*/    	
    	
    	Parse.initialize(this, "281498018688207","d44888c855959b44d17378039cefb59f");
		ParseFacebookUtils.initialize(getString(R.string.app_id));
    	ParseUser currentUser = ParseUser.getCurrentUser();
    	@SuppressWarnings("unused")
		Session session = ParseFacebookUtils.getSession();
    	
    	if ((currentUser != null) && ParseFacebookUtils.isLinked(currentUser))
    	{//se o usuario ja esta ativo entra direto na tela painel_opcoes
			showUserDetailsActivity();
		}		
    }
    
    /* onClick */
	OnClickListener click_btFacebook = new OnClickListener() 
	{
		/*
		 Faz a verificao se possui conectividade com a internet caso tenha chama o procedimento para logar
		 no Facebook, se no houver uma mensagem sera apresentada informando que esta sem conexo com a internet
		 */		
		
		@Override
		public void onClick(View v) 
		{
			if (VerificaConexao(MainActivity.this)) 
			{             
				onLoginButtonClicked();
            }
			else
			{  
                mostraAlerta("Alerta!","Sem conexo com a internet.");  
            }  
		}
	};     	
		
	/*
	 Procedimento para estar logando no Facebook, guarda as permisses em uma array  e faz a verificao 
	 no Site do Facebook informando ao usuario que o aplicativo ter acesso a algumas informaes, 
	 Caso o usuario aceite as permisses, ira chamar a ShowUserDetaisActivity para mostar as informacoes do Painel
	 Se o usuario recusar as permisses, voltara a tela inicial do aplicativo
	 */
	private void onLoginButtonClicked()
	{
		MainActivity.this.progressDialog = ProgressDialog.show(MainActivity.this, "Aguarde..", "Carregando informaes...", true);
		List<String> permissions = Arrays.asList("public_profile","user_hometown", "user_about_me","user_relationships", "user_birthday", "user_location","email","user_likes","user_work_history" );
		ParseFacebookUtils.logIn(permissions, this, new LogInCallback() {
			
			@Override  
			public void done(ParseUser user, ParseException err) 
			{
				MainActivity.this.progressDialog.dismiss();
				if (user == null)
				{
					Log.d(IntegracaoFacebook.TAG,"O usurio cancelou o login do Facebook.");
				}
				else 
					if (user.isNew())
					{
						Log.d(IntegracaoFacebook.TAG,"Usurio est cadastrado e logado atravs do Facebook!");
						showUserDetailsActivity();
					}
					else 
					{
						Log.d(IntegracaoFacebook.TAG,"Usurio conectado atravs do Facebook!");
						showUserDetailsActivity();
					}
			}
		}); 
	}
	
	/* 
	 * Faz a verificaao se o SmartPhone est conectado a internet, caso esteja retorna verdadeiro, o usuario
	 * conseguira ter acesso a informaes do aplicativo, se no houver conexo uma mensagem de erro seja 
	 * apresentado ao usuario informando a falta de conectividade
	 */
    public boolean VerificaConexao(Context classe)
    {  
        //Pego a conectividade do contexto passado como argumento  
        ConnectivityManager gerenciador = (ConnectivityManager) classe.getSystemService(Context.CONNECTIVITY_SERVICE);  
        //Crio a varivel informacao que recebe as informaes da Rede  
        NetworkInfo informacao = gerenciador.getActiveNetworkInfo();  
        //Se o objeto for nulo ou nao tem conectividade retorna false  
        
        if ((informacao != null) && (informacao.isConnectedOrConnecting()) && (informacao.isAvailable())) 
        {  
        	return true; 
        }  
        
        return false;  
    }   
    
	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) 
	{
		super.onActivityResult(requestCode, resultCode, data);
		ParseFacebookUtils.finishAuthentication(requestCode, resultCode, data);
	}
	
	// Mostra a informao caso no tenha internet.  
    private void mostraAlerta(String title, String mensagem)
    {  
        AlertDialog.Builder informa = new AlertDialog.Builder(MainActivity.this);  
        informa.setTitle(title).setMessage(mensagem);  
        informa.setNeutralButton("Voltar", null).show();   
    }  
    
    /*
     * Faz a chamada para a tela de Painel de opces caso o usuario esteja logado
     */
    private void showUserDetailsActivity()
    {
		Intent PainelOpc = new Intent(getApplicationContext(), Painel_Principal.class);
		startActivity(PainelOpc);
	}

    
    @Override
	public boolean onOptionsItemSelected(MenuItem item) 
	 {
		int id=item.getItemId();
	
		if(id == R.id.menu_sobre)
		{
			Intent PainelSobre = new Intent(getApplicationContext(), Tela_sobre_Painel_Inicial.class);
			startActivity(PainelSobre);
		}
		
		return super.onOptionsItemSelected(item);
	}
    
    @Override
	public boolean onCreateOptionsMenu(Menu menu)
    {
    	// Inflate the menu; this adds items to the action bar if it is present.
    	getMenuInflater().inflate(R.menu.config_inicio, menu);
    	return true;
	}
 }