package com.example.aplicativo;


import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.SparseBooleanArray;
import android.view.ActionMode;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AbsListView;
import android.widget.AbsListView.MultiChoiceModeListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.Toast;

/*
 * Classe responsavel para mostrar os usuarios que enviaram mensagem e usuario que enviei mensagem
 */

public class Painel_Mensagens extends Activity implements MultiChoiceModeListener 
{

	ListView listView;
	List<RowItem> rowItems;

	long timeInMilliseconds = 0L;
	long timeSwapBuff = 0L;
	long updatedTime = 0L;
	long startTime = 0L;
	
	private String MeuNome;
	private int UserId;
	private int MeuId;
	
	private ProgressDialog dialog;
	List<UsuarioChat> usuario;
	UsuarioChat user;
	CustomListViewAdapter adapter;
	
	@Override
	protected void onCreate(final Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
	    setContentView(R.layout.tela_mensagens);
	    inicializa();
	    
	} 

	/*
	 * inicializo todas as informaes do painel de mensagem
	 */
	public void inicializa()
	{
		RecebeDados();
		linkView();
		
		dialog = ProgressDialog.show(Painel_Mensagens.this, "Aguarde..", "Carregando informaes...", true);
		usuario = new ArrayList<UsuarioChat>();
		GlobalClass globalVariable = (GlobalClass) getApplicationContext();
		globalVariable.setGlobal(0);
	}
	
	public void linkView()
	{
		listView = (ListView) findViewById(R.id.painel_mensagens_listView1);
	}
	
	/*
	 * recebe informaes da classe anterior
	 */
	public void RecebeDados()
	{
		GlobalClass informacoes = (GlobalClass) getApplicationContext();
		Intent intent = getIntent();
    	
		if(intent != null)
		{
    		Bundle extras = intent.getExtras();
    		
    		if(extras != null)
    		{    			
    			MeuId = extras.getInt("MeuID");
    			MeuNome = extras.getString("MeuNome");
    		}
    		else
    		{
    			MeuId = informacoes.getMeuID();
    			MeuNome = informacoes.getMeuNome();
    		}
    		CarregaInformacoes();
    	} 
    }   
	
	/*
	 * Verifica novas mensagens APENAS do chat, envio o ID da conversa obtida no procedimento
	 * criaconversa e retorna a mensagem
	 */
	public void CarregaInformacoes()
	{
		
		AsyncTask<Void, Void, Void> task = new AsyncTask<Void, Void, Void>()
		{
		    public String Conteudo;
		    String data = ""; 
			
		    @Override
			protected Void doInBackground(Void... params) 
			{
		    	BufferedReader reader = null;
		    	
		    	try
		    	{ 
		    		// Define a URL que esta enviando os dados
		    		URL url = new URL("http://www.brunodeandrade.com.br/luciano/chat_tudo.php?id_recv="+MeuId);
		    		URLConnection conn = url.openConnection(); 
		    		conn.setDoOutput(true); 
		            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream()); 
		            wr.write( data ); 
		            wr.flush(); 
		            //Pego a resposta do servidor 
		            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            StringBuilder sb = new StringBuilder();
		            String line = null;
		            
			        // escrevo a resposta do servidor
			        while((line = reader.readLine()) != null)
			        {
			        	// Acrescento a resposta do servidor em uma string
			            sb.append(line + "\n");
			        }
		            // Acrescento a resposta do servidor no Content string
		            Conteudo = sb.toString();
		    	}
		    	catch(Exception ex)
		    	{
		    		ex.getMessage();
		    	}
		    	finally
		    	{
		    		try
		    		{
		    			reader.close();
		            }
		    		catch(Exception ex) {
		            	
		            }
		    	}
		        return null;
			}
			
		    @Override 
			protected void onPreExecute() 
		    { 
				super.onPreExecute(); 
			}
			
		    @Override
			protected void onPostExecute(Void result)
		    {
				super.onPostExecute(result); 
				try 
				{
					int encontrou=0;
					String NomeAux;
					NomeAux = MeuNome.replace("%20"," ");
					
			        JSONArray jsonResposta = new JSONArray(Conteudo);
			        
					int TamanhoJsonArr = jsonResposta.length();
				
					for(int i = 0; i < TamanhoJsonArr; i++)
					{
						JSONObject jsonObject = jsonResposta.getJSONObject(i);
						String Nomebanco = jsonObject.getString("nome");
						String NomebancoRecv = jsonObject.getString("nome_recv");
						encontrou = 0;
					
						for(int j = 0; j < usuario.size(); j++)
						{//verifica se ja possui o cara na lista						
							if(Nomebanco.equalsIgnoreCase(usuario.get(j).nome))
							{
								if(usuario.get(j).status==1){
									System.out.println("MUDA NAO FI DUMA EGUA");
								}else{
									usuario.get(j).status = jsonObject.getInt("status_server");	
									encontrou = 1;
								}
									
								
							//	CriaLista();
							}
						}
						
						if(encontrou == 0)
						{//elimina o usuario igual da lista
							/*
							 * verificao para saber se  usuario que enviei mensagem ou se  o que recebi mensagem
							 */
							if(NomeAux.equalsIgnoreCase(Nomebanco))
							{
								//outra variavel com nome vindo do banco
								//String TesteNome = "Maria Lucia Silva Oliveira";
								//int TesteID = 374;
								int ok = 0;
								
								for(int m = 0; m < usuario.size(); m++)
								{//percorro a lista inteira pra ver se esse cara existe na lista
								
									if(usuario.get(m).nome.equalsIgnoreCase(NomebancoRecv))
									{//caso exista eu mudo algumas informaes
										usuario.get(m).nome = jsonObject.getString("nome_recv");
										usuario.get(m).id = jsonObject.getInt("id_recv"); //pego o outro ID vindo do banco
										if(usuario.get(m).status==1){
											ok=1;
										}else{
											//usuario.get(m).status = 0;//jsonObject.getInt("status_server");
											ok = 1;
										}
									}
								}
								if(ok == 0)
								{//se nao encontrar o segundo nome que veio do banco eu cadastro
									user = new UsuarioChat();
									user.id = jsonObject.getInt("id_recv");
									user.status = 0;//receve zero por foi eu que enviei
									user.nome = jsonObject.getString("nome_recv");
									user.mensagem = jsonObject.getString("mensagem");
									user.id_conversa = jsonObject.getInt("codigo_mensagem");
									usuario.add(user);
							
								}
							}else//se  diferente entao  mensagem que eu recebi
							{							
								user = new UsuarioChat();
								user.id = jsonObject.getInt("id_send");
								user.status = jsonObject.getInt("status_server");
								user.nome = jsonObject.getString("nome");
								user.mensagem = jsonObject.getString("mensagem");
								user.id_conversa = jsonObject.getInt("codigo_mensagem");
								usuario.add(user);
							}
						}						
					}
					CriaLista();
					dialog.dismiss();//finaliza o dialog "mensagem de carregando"
			    } 
				catch (JSONException e) 
				{
			    	e.printStackTrace();
			    }
			}
		};
		task.execute();
	}
	
	public void imprime(){
		for(int i = 0; i<usuario.size(); i++){
			System.out.println(usuario.get(i).nome+"|"+usuario.get(i).status+"\n");
		}
	}
	public void CriaLista()
	{
		rowItems = new ArrayList<RowItem>();
		
		for(int i = 0; i<usuario.size(); i++)
		{
			
			if(usuario.get(i).status==1)
			{
				RowItem item = new RowItem("new", usuario.get(i).nome, usuario.get(i).id, usuario.get(i).id_conversa);
				rowItems.add(item);
			}
			else
			{
				RowItem item = new RowItem("", usuario.get(i).nome, usuario.get(i).id, usuario.get(i).id_conversa);
				rowItems.add(item);
			}
		}
		
		adapter = new CustomListViewAdapter(this, R.layout.list_item, rowItems);
        listView.setAdapter(adapter);
        listView.setMultiChoiceModeListener(this);
        listView.setChoiceMode(AbsListView.CHOICE_MODE_MULTIPLE_MODAL);
        listView.setOnItemClickListener(Click);
        imprime();
	}
	
	OnItemClickListener Click =  new OnItemClickListener() 
	{
		
		public void onItemClick(AdapterView<?> parent, View view, int position,long id) 
		{
		        int tipo = 1; 
				
				UserId = usuario.get(position).id;
				System.out.println(UserId);
				Bundle extras = new Bundle();
				extras.putString("Nome", usuario.get(position).nome);
				extras.putString("MeuNome", MeuNome);
				extras.putInt("MeuID", MeuId);
				extras.putInt("UserID", UserId);
				extras.putInt("Tipo",tipo);
				extras.putInt("New", usuario.get(position).status);
				
				Intent ChamaChat = new Intent(getApplicationContext(),Tela_de_chat_do_usuario.class);
				ChamaChat.putExtras(extras);//envia o parametro
				finish();
				startActivity(ChamaChat);
		}
	}; 	
	
	public void ToastMake(String Msg)
	{
		Toast.makeText(this,Msg,Toast.LENGTH_SHORT).show();
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) 
	{
		System.out.println("menuitem");
		int id=item.getItemId();
	
		if(id == R.id.painel_opcoes_sobre)
		{
			Intent PainelSobre = new Intent(getApplicationContext(), Tela_sobre_Painel_Mensagens.class);
			startActivity(PainelSobre);
		}
		
		return super.onOptionsItemSelected(item);
	}
	
	public boolean onCreateOptionsMenu(Menu menu) 
	{
		 // Inflate the menu; this adds items to the action bar if it is present.
		 getMenuInflater().inflate(R.menu.config_chat, menu);
		 return true;
	}
	/*
	 * Ao excluir uma conversa envio uma informao para o banco indicando que nao quero mais receber
	 * nada at o momento deste usuario
	 */
	public void ExcluiConversa(final int codigo_conversa)
	{
		
		AsyncTask<Void, Void, Void> task = new AsyncTask<Void, Void, Void>()
		{
		    String data =""; 
			@Override
			protected Void doInBackground(Void... params) 
			{
		    	BufferedReader reader=null;
		
		    	try
		    	{ 
		    		
		    		URL url = new URL("http://www.brunodeandrade.com.br/luciano/delete.php?cod_msg="+codigo_conversa+"&meu_id="+MeuId);
		    		URLConnection conn = url.openConnection(); 
		    		conn.setDoOutput(true); 
		            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream()); 
		            wr.write( data ); 
		            wr.flush(); 
		            //Pego a resposta do servidor 
		            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            StringBuilder sb = new StringBuilder();
		            String line = null;
		            
			        // escrevo a resposta do servidor
			        while((line = reader.readLine()) != null)
			        {
			        	// Acrescento a resposta do servidor em uma string
			            sb.append(line + "\n");
			        }
		            sb.toString();
		    	}
		    	catch(Exception ex)
		    	{
		    		ex.getMessage();
		    	}
		    	finally
		    	{
		    		try
		    		{
		    			reader.close();
		            }
		    		catch(Exception ex) {
		            	
		            }
		    	}
		        return null;
			}
			
			@Override 
			protected void onPreExecute() 
			{ 
				super.onPreExecute(); 
			}
			
			@Override
			protected void onPostExecute(Void result)
			{
				super.onPostExecute(result);
			}
		};
		task.execute();
	}
	
	/*
	 * Remove o usuario da listview, envia para o servidor uma informao dizendo que nao quer mais
	 * ver esse usuario
	 */
	public void Realocalista(int ID)
	{
		
		for(int i = 0; i < usuario.size(); i++)
		{
		
			if(ID == usuario.get(i).id)//localizo o usuario especifico
			{
				usuario.remove(i);
			}
		}
	}
	
	/*
	 * Remove o item selecionado, e remove as informacoes do banco de dados
	 */
	@Override
	public boolean onActionItemClicked(ActionMode mode, MenuItem position) 
	{
	
		switch (position.getItemId()) 
		{
			
			case R.id.delete:
				SparseBooleanArray selected = adapter.getSelectedIds();
				
				for (int i = (selected.size() - 1); i >= 0; i--) 
				{
				
					if (selected.valueAt(i)) 
					{
						
						if (VerificaConexao(Painel_Mensagens.this)) 
						{             
							RowItem selecteditem = adapter.getItem(selected.keyAt(i));
							Realocalista(selecteditem.getID());
							ExcluiConversa(selecteditem.getID_Conversa());
							adapter.remove(selecteditem);	
				        }
						else 
						{  
				        	ToastMake("Erro ao excluir, verifique sua internet!");
				        }  
					}
				}	
			mode.finish();
			return true;
			default:
				return false;
		}
	}
	/* 
	 * Faz a verificaao se o SmartPhone est conectado a internet, caso esteja retorna verdadeiro, o usuario
	 * conseguira ter acesso a informaes do aplicativo, se no houver conexo uma mensagem de erro seja 
	 * apresentado ao usuario informando a falta de conectividade
	 */
	public boolean VerificaConexao(Context classe) 
	{  
        //Pego a conectividade do contexto passado como argumento  
        ConnectivityManager gerenciador = (ConnectivityManager) classe.getSystemService(Context.CONNECTIVITY_SERVICE);  
        //Crio a varivel informacao que recebe as informaes da Rede  
        NetworkInfo informacao = gerenciador.getActiveNetworkInfo();  
        //Se o objeto for nulo ou nao tem conectividade retorna false  
        
        if ((informacao != null) && (informacao.isConnectedOrConnecting()) && (informacao.isAvailable())) 
        {  
        	return true; 
        }  
        return false;  
    }   
	
	@Override
	public boolean onCreateActionMode(ActionMode mode, Menu menu) 
	{
		mode.getMenuInflater().inflate(R.menu.config_menu_chat, menu);
		return true;
	}
	
	@Override
	public void onDestroyActionMode(ActionMode mode) 
	{
		adapter.removeSelection();
	}
	
	@Override
	public boolean onPrepareActionMode(ActionMode mode, Menu position) 
	{
		return false;
	}
	
	@Override
	public void onItemCheckedStateChanged(ActionMode mode, int position, long id, boolean checked) 
	{
		final int checkedCount = listView.getCheckedItemCount();
		mode.setTitle(checkedCount + " Selecionado");
		adapter.toggleSelection(position);			
	}
}
