package com.example.aplicativo;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class Tela_Sem_Internet extends Activity
{
	
	private Button BtAtualizar;
	@Override
	
	protected void onCreate(final Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
	    setContentView(R.layout.tela_sem_internet);
	    linkView();
	} 
	
	private void linkView()
	{
		BtAtualizar = (Button)findViewById(R.id.tela_sem_internet_btAtualizar);
		BtAtualizar.setOnClickListener(click_BtAtualizar);
	}
	
	/* onClick */
    OnClickListener click_BtAtualizar = new OnClickListener()
    {
	
    	@Override
		public void onClick(View v) 
    	{
			if (VerificaConexao(Tela_Sem_Internet.this)) 
			{
				finish();		
            } 
			else 
			{  
                ToastMake("Sem conexo com a internet.");  
            }  
		}
	};
	
	/*
	 * Mensagem de informao
	 */
	public void ToastMake(String Msg)
	{
		Toast.makeText(this,Msg,Toast.LENGTH_SHORT).show();
	}
	
	/*
	 * Verifica se existe conexo com a internet
	 */
	public boolean VerificaConexao(Context classe) 
	{  
       //Pego a conectividade do contexto passado como argumento  
       ConnectivityManager gerenciador = (ConnectivityManager) classe.getSystemService(Context.CONNECTIVITY_SERVICE);  
       //Crio a varivel informacao que recebe as informaes da Rede  
       NetworkInfo informacao = gerenciador.getActiveNetworkInfo();  
       //Se o objeto for nulo ou nao tem conectividade retorna false  
       
       if ((informacao != null) && (informacao.isConnectedOrConnecting()) && (informacao.isAvailable())) 
       {  
       		return true; 
       }  
       
       return false;  
	}  
	
	public void onBackPressed() 
	{
        Intent intent = new Intent();
        intent.setAction(Intent.ACTION_MAIN);
        intent.addCategory(Intent.CATEGORY_HOME);
        startActivity(intent);
        return;
    }
}

