package com.example.aplicativo;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.google.android.gms.maps.CameraUpdate;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.CancelableCallback;
import com.google.android.gms.maps.GoogleMap.OnInfoWindowClickListener;
import com.google.android.gms.maps.GoogleMap.OnMarkerClickListener;
import com.google.android.gms.maps.GoogleMapOptions;
import com.google.android.gms.maps.LocationSource;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;

import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Toast;

public class Tela_com_Mapa extends FragmentActivity implements LocationListener 
{
	@SuppressLint("SimpleDateFormat")
	private SimpleDateFormat Data_Sistema = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
	@SuppressLint("SimpleDateFormat")
	private SimpleDateFormat Dia = new SimpleDateFormat("yyyy/MM/dd");
	
	private LocationManager locationManager;
	private GoogleMap map=null;
	ProgressDialog dialog=null;
	Marker marker = null;
	List<Usuario> usuario;//lista com todos os usuarios cadastrados no banco de dados
	Usuario user;	
	
	private String nomeUsuario;
	private String email;

	private boolean allowNetwork;
	private int contador_marker=0;
	private int Id_selecionado;
	private double distancia;//distancia dos usuarios proximos
	private double lat_Ant=0;
	private double lon_Ant=0;
	private double lat= 0;
	private double lon=0;
	private int Iniciou=1;
	private int MinhaID;
	private int Tipo=1;//variavel para saber qual tipo de mapa sera mostrado

	@Override
	protected void onCreate(final Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.tela_com_mapa);
		inicializa();
		linkView();	
	}	
	
	public void inicializa()
	{
	/*
	 * inicializa os procedimentos do mapa
	 */
		if (VerificaConexao(Tela_com_Mapa.this)) 
		{
			usuario = new ArrayList<Usuario>();
			IniciaMapa();
			configMap();
			RecebeLimite();	
			
        }
		else 
		{
        	TelaSemInternet();
        }  
	}
	
	private void linkView()
	{
		map.setOnMarkerClickListener(click_marcador);
		map.setOnInfoWindowClickListener(click_caixa);
	}	
	
	/* onClick */
	OnMarkerClickListener click_marcador = new GoogleMap.OnMarkerClickListener() 
	{
		
		@Override
		public boolean onMarkerClick(Marker marker) 
		{
			marker.setDraggable(false);
			String str = marker.getId();
            str = str.substring(1);
            Id_selecionado = Integer.parseInt(str);
            //Toast.makeText(getApplicationContext(),str, Toast.LENGTH_LONG).show();
			return false;
		}
	};
	
	OnInfoWindowClickListener click_caixa = new GoogleMap.OnInfoWindowClickListener() 
	{
		
		@Override
		public void onInfoWindowClick(Marker marker) 
		{

			if (VerificaConexao(Tela_com_Mapa.this)) 
			{  
				marker.setDraggable(false);		
				Bundle extras = new Bundle();
				System.out.println("MarcadorSelect"+Id_selecionado);
				System.out.println(usuario.get(Id_selecionado).nome);
				extras.putInt("MeuID",MinhaID);
				extras.putString("NomeUser",usuario.get(Id_selecionado).nome);
				extras.putString("Idioma",usuario.get(Id_selecionado).idioma);
				extras.putString("Email",usuario.get(Id_selecionado).email);
				extras.putString("Cidade",usuario.get(Id_selecionado).cidade);
				extras.putString("Data",usuario.get(Id_selecionado).data);
				extras.putString("Id",usuario.get(Id_selecionado).id);
				extras.putString("Status",usuario.get(Id_selecionado).status);
				extras.putString("Distancia",usuario.get(Id_selecionado).distancia);
				extras.putString("Id_marcador",usuario.get(Id_selecionado).id_marcador);
				extras.putString("MeuNome", nomeUsuario);
				
				Intent TelaMapa = new Intent(getApplicationContext(),Informacoes_Usuario_Selecionado.class);
				TelaMapa.putExtras(extras);//envia o parametro
				startActivity(TelaMapa);	
	        }
			else //caso nao tenha internet uma mensagem sera informada
	        {
	        	TelaSemInternet();
	        }
		}
	};
	
	/*
	 * Faz o controle caso esteja ativado ou pausado o sistema, a cada 1 minuto atualizo a posicao do GPS
	 */
	@Override
	public void onResume()
	{
		super.onResume();
		System.out.println("Resume Mapa");
		allowNetwork = true;
		locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);		
		
		if(!locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER))
		{
			Intent it = new Intent(android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS);
			startActivity(it);
		}
		else
		{
			locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 1 * 30 * 1000, 0f, this);
			locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 1 * 30 * 1000, 0f, this);
		}
	}
	
	@Override
	public void onPause()
	{
		super.onPause();
		System.out.println("Pause Mapa");
		locationManager.removeUpdates(this);
	}
	
	@Override
	public void onDestroy()
	{
		super.onDestroy();
		finish();
	}
	/*
	 * Faz a inicializao do mapa
	 */
	public void IniciaMapa()
	{
		dialog = ProgressDialog.show(Tela_com_Mapa.this, "Processando...", "Localizando coordenada, Por Favor Aguarde...");
		GoogleMapOptions options = new GoogleMapOptions();
		options.zOrderOnTop(true);
		map = ((SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.mostra_mapa_map)).getMap();
		//salvo a ultima cordenada do gps
		lat_Ant=lat;
		lon_Ant=lon;
	}
	
	/*
	 * Recebe as informaes da outra classe para que possa pegar as informaes necessarias
	 */
	public void RecebeLimite()
	{//recebe o valor da barra de progresso 
    	Intent intent = getIntent();

    	if(intent != null)
    	{
    		Bundle extras = intent.getExtras();
    	
    		if(extras != null)
    		{
    			distancia = extras.getInt("limite");
    			MinhaID = extras.getInt("MinhaID");
    			nomeUsuario = extras.getString("nome");
    			extras.putString("email", email);
    		}
    	}
    }
	
	/*
	 * Faz a movimentao da camera para o meu ponto no mapa
	 * Aguarda um tempo para movimentar a camera lentamente
	 */
	public void MoveCamera(final LatLng latLng)
	{
		
		CameraPosition cameraPosition = new CameraPosition.Builder().target(latLng).zoom(16).bearing(0).tilt(0).build();
		final CameraUpdate update = CameraUpdateFactory.newCameraPosition(cameraPosition);
		
		map.setMyLocationEnabled(true);
		
		//movimenta a camera para o meu ponto depois de um tempo
		map.animateCamera(update, 1000, new CancelableCallback(){
			
			@Override
			public void onCancel() 
			{
				Log.i("Script", "1.CancelableCallback.onCancel()");
			}
			
			@Override
			public void onFinish() {
				System.out.println("Retorno para minha posio atual");
			}
		});
	}
	/*
	 * Faz a escolha do tipo de mapa a ser mostrado ao usuario
	 */
	public void TipoMapa(int TipoMap)
	{
		
		if(TipoMap == 1)
		{
			map.setMapType(GoogleMap.MAP_TYPE_NORMAL);
		}
		
		if(TipoMap == 2)
		{
			map.setMapType(GoogleMap.MAP_TYPE_TERRAIN);
		}
		
		if(TipoMap == 3)
		{
			map.setMapType(GoogleMap.MAP_TYPE_SATELLITE);
		}
	}
	
	/*
	 * Chamo os procedimentos para Tipo de mapa e localizaco de camera
	 */
	public void configMap()
	{
		TipoMapa(Tipo);
		LatLng latLng = new LatLng(lat,lon);
		configLocation(latLng);
	}	
	
	/*
	 * Chama o procedimento para localizao da camera
	 */
	public void configLocation(LatLng latLng)
	{
		
		if (VerificaConexao(Tela_com_Mapa.this))
		{  
			MoveCamera(latLng);		
			MyLocation myLocation = new MyLocation();
			map.setLocationSource(myLocation);
			myLocation.setLocation(latLng);	
        }
		else 
        {  
        	TelaSemInternet();
        }  
	}
	/*
	 * Formula para saber a distancia entre minha posio a um ponto qualquer
	 */
	public int FormulaDistancia(double lat_servidor, double long_servidor, double lat, double lon)
	{
		double Raio = 6371.0;
	    double Pi = 3.14;
	    double resultado, valores;
	    double lat_res,lon_res;
	    double lat_temp = 0, lon_temp = 0;
	    int distancia;
		lat_temp = lat * Pi / 180;
		lon_temp = lon * Pi / 180;
		lat_servidor = lat_servidor * Pi / 180;
		long_servidor = long_servidor * Pi / 180;
		
		lat_res = lat_servidor - lat_temp;
		lon_res = long_servidor - lon_temp;
		valores= Math.sin(lat_res / 2) * Math.sin(lat_res / 2) + Math.cos(lat_temp) * Math.cos(lat_servidor) * Math.sin(lon_res / 2) * Math.sin(lon_res / 2);
		valores = 2 * Math.atan2(Math.sqrt(valores),Math.sqrt(1 - valores));
		resultado = Math.round(Raio * valores * 1000);
		distancia = (int) resultado;
		return distancia;
	}
	
	/*
	 * Faz a verificao se estou movendo, caso esteja envia minha nova coordenada para o banco de dados
	 * apenas se for maior que 30 metros, e atualizo os marcadores do mapa
	 */
	public class MyLocation implements LocationSource
	{
		private OnLocationChangedListener listener;
		@Override
		
		public void activate(OnLocationChangedListener listener) 
		{
			this.listener = listener;
			int Resul = 0;
			Resul = FormulaDistancia(lat_Ant, lon_Ant,lat, lon);
		
			if(Resul>30)
			{//a cada 30 metros atualiza o banco de dados		
			
				if (VerificaConexao(Tela_com_Mapa.this)) 
				{  
					new Enviar_Meus_dados_banco_dados(lat, lon, MinhaID).execute();//envio minha coordenada para o banco de dados
					GetDados();	
		        }
				else 
				{
		        	TelaSemInternet();
		            //ToastMake("Erro ao atualizar, verifique a conexo com a internet.");
		        }				
			}
		}
		
		@Override
		public void deactivate() 
		{
			System.out.println("Desativado");
		}
		/*
		 * Encontro minha localizaco, e guardo em uma variavel auxiliar para estar sendo utilizada posteriormente
		 */
		public void setLocation(LatLng latLng)
		{
			Location location = new Location(LocationManager.GPS_PROVIDER);
			location.setLatitude(latLng.latitude);
			location.setLongitude(latLng.longitude);
			lat = latLng.latitude;
			lon = latLng.longitude;
			if(listener != null)
			{
				listener.onLocationChanged(location);
			}
		}
	}
	
	/*
	 * Faz a verificao de qual tipo de localizao sera efetuada e fico buscando novas atualizao da minha posio
	 */
	@Override
	public void onLocationChanged(Location location) 
	{
		
		if(location.getProvider().equals(LocationManager.GPS_PROVIDER))
		{
			allowNetwork = false;
		}
		
		if(allowNetwork || location.getProvider().equals(LocationManager.GPS_PROVIDER))
		{
			configLocation(new LatLng(location.getLatitude(), location.getLongitude()));
		}
		//quando encontrar uma localizacao fecha o dialog e baixa pacote do banco de dados
		
		if(Iniciou == 1)
		{
		
			if (VerificaConexao(Tela_com_Mapa.this)) 
			{  
				dialog.dismiss();//finaliza o dialog "mensagem de carregando"
				GetDados();	
	        }
			else 
			{  
	        	TelaSemInternet();
	        }
		}
	}
	
	/*
	 * Caso o usuario desabilite o GPS, esse procedimento verifica e volta para a tela de Painel_Opcoes
	 */
	@Override
	public void onProviderDisabled(String provider) 
	{
		dialog.dismiss();//finaliza o dialog "mensagem de carregando"
		ToastMake("O GPS foi desabilitado.");
		PainelActivity();
	}
	
	/*
	 * Caso o usuario habilite o Gps, atualiza os marcadores
	 */
	@Override
	public void onProviderEnabled(String provider) 
	{
		
		if (VerificaConexao(Tela_com_Mapa.this)) 
		{  
			GetDados();	
        }
		else
		{
        	TelaSemInternet();
        }
	}
	
	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
	}
	
	/*
	 * Adiciona os marcaores no mapa	
	 */
	public void customAddMarker(LatLng latLng, String title, String snippet, int id_user,int Distancia_usuario)
	{		
		MarkerOptions options = new MarkerOptions();
		
		options.position(latLng).title(""+title).snippet("Distncia: "+Distancia_usuario+" m ( + inf.)").draggable(true);
		map.addMarker(options);
	}
	
	/*
	 * Pega as informaes do Banco de dados e atualiza o mapa
	 */
	public void GetDados()
	{
	
		AsyncTask<Void, Void, Void> task = new AsyncTask<Void, Void, Void>()
		{
			
		    public String Conteudo;
		    String data ="";
		    
		    int id_usuario;
		    double lat_servidor,long_servidor;
		    int RE; 
			@Override
			protected Void doInBackground(Void... params) 
			{
		    	BufferedReader reader=null;
		    	try
		    	{ 
		    		// Define a URL que esta enviando os dados
		    		URL url = new URL("http://www.brunodeandrade.com.br/luciano/luciano.php");
		    		URLConnection conn = url.openConnection(); 
		    		conn.setDoOutput(true); 
		            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream()); 
		            wr.write( data ); 
		            wr.flush(); 
		            //Pego a resposta do servidor 
		            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            StringBuilder sb = new StringBuilder();
		            String line = null;
		            
			        // escrevo a resposta do servidor
			        while((line = reader.readLine()) != null)
			        {
			        	// Acrescento a resposta do servidor em uma string
			            sb.append(line + "\n");
			        }
		            // Acrescento a resposta do servidor no Content string
		            Conteudo = sb.toString();
		            System.out.println(Conteudo);
		    	}
		    	
		    	catch(Exception ex)
		    	{
		    		ex.getMessage();
		    	}
		    	
		    	finally
		    	{
		    		try
		    		{
		    			reader.close();
		            }
		    		catch(Exception ex) 
		    		{
		            	
		            }
		    	}
		        return null;
			}
			
			@Override 
			protected void onPreExecute() 
			{ 
				super.onPreExecute();
				
				if (VerificaConexao(Tela_com_Mapa.this))//envia minha coordenada para o banco de dados 
				{  
					Iniciou = 2;
					lat_Ant=lat;
					lon_Ant=lon;
					new Enviar_Meus_dados_banco_dados(lat,lon,MinhaID).execute();//envio minha coordenada para o banco de dados
					dialog = ProgressDialog.show(Tela_com_Mapa.this, "Processando...", "Baixando dados, Por Favor Aguarde...");
		        }
				else
				{
		        	TelaSemInternet();
		            //ToastMake("Erro ao atualizar, verifique a conexo com a internet.");
		        }
			}
			
			@Override
			protected void onPostExecute(Void result)
			{
				super.onPostExecute(result);
				try 
				{
					map.clear();//limpo todos os marcadores	
			    	//Cria um novo JSONOBject com nome vindo da JSON string
			        JSONArray jsonResposta = new JSONArray(Conteudo);
					int TamanhoJsonArr = jsonResposta.length();  
					
					for(int i = 0; i < TamanhoJsonArr; i++) 
					{
						JSONObject jsonObject = jsonResposta.getJSONObject(i);
						String longitude = jsonObject.getString("longitude");
						String latitude = jsonObject.getString("latitude");
						String idioma = jsonObject.getString("idioma");
						String cidade = jsonObject.getString("cidade");
						String status = jsonObject.getString("status");
						String email = jsonObject.getString("email");
			            String nome = jsonObject.getString("nome");
			            String data = jsonObject.getString("data");
			            id_usuario= jsonObject.getInt("id");
	
			            //calculo para distancia
			            long_servidor = Double.parseDouble(longitude);//cliente
			            lat_servidor = Double.parseDouble(latitude);//cliente
						RE= FormulaDistancia(lat_servidor, long_servidor,lat, lon);
						/*
						 * faz a verificao de atividade do usuario, caso o usuario esteja ativo hoje
						 * mostra ele no mapa
						 */
						
						Date today = Calendar.getInstance().getTime();
						data = data.replace("-","/");//arrumando formato da data
						String aux = Dia.format(today);//salvo a data atual em uma variavel auxiliar
						String Data_Auxiliar = "";
						String data_banco = "";
					
						for(int k=0;k<aux.length();k++)
						{//percorro a variavel auxiliar para retirar apenas a data
							
							if(k<=9)
							{ 
								Data_Auxiliar=Data_Auxiliar+aux.charAt(k);//salvo a data atual
							}
						}	
						
						for(int k=0;k<String.valueOf(data).length();k++)
						{//percorro a variavel com a data do banco
							
							if(k<=9)
							{
								data_banco=data_banco+String.valueOf(data).charAt(k);//salvo a data do banco
							}
						}	
						
						if(Data_Auxiliar.equalsIgnoreCase(data_banco))
						{//verifica se ficou on nesse mesmo dia					
						
							if(RE <= distancia)
							{//se estiver na distancia desejada adiciona marcador
								user = new Usuario();
								user.id_marcador = String.valueOf(contador_marker);
								user.id = String.valueOf(id_usuario);
								user.distancia = String.valueOf(RE);
								user.idioma = idioma;
								user.cidade = cidade;
								user.status = status;
								user.email = email;
								user.nome = nome;
								user.data = data;
								usuario.add(user);
								
								if(lat_servidor != lat && long_servidor != lon)
								{//elimino minha posicao
								
									if(nome.equalsIgnoreCase(nomeUsuario))
									{//ignora meu dados para nao aparecer no marcador
										System.out.println("nome igual"); 
										MinhaID=id_usuario;
									}
									else
									{
										customAddMarker(new LatLng( Double.parseDouble(latitude),Double.parseDouble(longitude)), nome, idioma,id_usuario,RE);
										contador_marker++;
									}
									
								}
								
							}
							
						}
						
					} 					
					ToastMake("Dados atualizados com sucesso!");//informa que foi realizado com sucesso
					dialog.dismiss();//finaliza o dialog "mensagem de carregando"
			    } 
				catch (JSONException e) 
				{
			    	e.printStackTrace();
			    }
			}
		};
		task.execute();
	}
	
	/*
	 * Procedimento para janela de mensagem de informao
	 */
	public void ToastMake(String Msg)
	{
		Toast.makeText(this,Msg,Toast.LENGTH_SHORT).show();
	}
	
	/*
	 * Options Select, atualiza as informaes escolhidas do usuario 
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) 
	{
		int id=item.getItemId();
		
		if(id == R.id.menu_atualizar)
		{
			map.clear();//limpo todos os marcadores
			Iniciou=1;//mudo o valor pois foi o usuario que pediu para atualizar
			inicializa();						
		}
		
		if(id == R.id.Tipo_Normal)
		{
			map.clear();//limpo todos os marcadores
			Iniciou=1;//mudo o valor pois foi o usuario que pediu para atualizar
			Tipo=1;
			inicializa();
		}
		
		if(id == R.id.Tipo_Satelite)
		{
			map.clear();//limpo todos os marcadores
			Iniciou=1;//mudo o valor pois foi o usuario que pediu para atualizar
			Tipo=3;
			inicializa();
		}
		
		return super.onOptionsItemSelected(item);
	}
	
	/* 
	 * Faz a verificaao se o SmartPhone est conectado a internet, caso esteja retorna verdadeiro, o usuario
	 * conseguira ter acesso a informaes do aplicativo, se no houver conexo uma mensagem de erro seja 
	 * apresentado ao usuario informando a falta de conectividade
	 */
	public boolean VerificaConexao(Context classe) 
	{  
       //Pego a conectividade do contexto passado como argumento  
       ConnectivityManager gerenciador = (ConnectivityManager) classe.getSystemService(Context.CONNECTIVITY_SERVICE);  
       //Crio a varivel informacao que recebe as informaes da Rede  
       NetworkInfo informacao = gerenciador.getActiveNetworkInfo();  
       //Se o objeto for nulo ou nao tem conectividade retorna false  
       
       if ((informacao != null) && (informacao.isConnectedOrConnecting()) && (informacao.isAvailable())) 
       {  
       		return true; 
       }  
       
       
       return false;  
   }  
	/*
	 * Chama tela com erro de internet
	 */
	private void TelaSemInternet()
	{
		Intent TelaSemInternet = new Intent(getApplicationContext(), Tela_Sem_Internet.class);
		startActivity(TelaSemInternet);
	}
	
	// Mostra a informao caso no tenha internet. 
	private void PainelActivity() 
	{
		Intent intent = new Intent(this, Painel_Principal.class);
		Tela_com_Mapa.this.finish();
		intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		startActivity(intent);
	}
	
	public boolean onCreateOptionsMenu(Menu menu) 
	{
		 // Inflate the menu; this adds items to the action bar if it is present.
		 getMenuInflater().inflate(R.menu.config_mostra_mapa, menu);
		 return true;
	}
}