package com.example.aplicativo;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.SystemClock;
import android.os.Vibrator;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class Tela_de_chat_do_usuario extends Activity 
{
	private ProgressDialog CarregandoMensagensDialog;
	private Handler customHandler = new Handler();
	public ArrayAdapter<String> msgList;
	private String MensagemNotificacao;
	private TextView userNameView;
	private boolean CancelaErro;
	private String nomeUsuario;
	public ListView msgView;
	public Button bt_enviar; 
	private String MeuNome;
	
	private long timeInMilliseconds = 0L;
	private long timeSwapBuff = 0L;
	private long updatedTime = 0L;
	private long startTime = 0L;
	
	private int ID_Conversa;
	private int possui = 0;
	private int tipo = 0;
	private int UserId;
	private int MeuId;
		
	@Override
	protected void onCreate(final Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
	    setContentView(R.layout.tela_de_chat_do_usuario);	    
	    inicializa();	    
	} 
	
	private void inicializa() 
	{
		linkView();
		RecebeDados();    			
		/*
		 * Faz a verificao para saber se existe conexao com a internet para estar obtendo informaes necessarias
		 * do banco de dados.
		 */
		if (VerificaConexao(Tela_de_chat_do_usuario.this)) 
		{	
			if(possui==1){
				CarregandoMensagensDialog = ProgressDialog.show(Tela_de_chat_do_usuario.this, "Aguarde..", "Recebendo mensagem...", true);
			}
			CancelaErro = false;//variavel utilizada para nao ficar mostrando a todo momento mensagem informando sem conexao com a internet
			CriaConversa();
		    Temporizador();
        }else{  
            ToastMake("Sem conexo com a internet.");  
        }  	    		
	}	
	
	private void linkView()
	{
		msgView = (ListView) findViewById(R.id.tela_mensagens_listView);
	    msgList = new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1);
		msgView.setAdapter(msgList);		
		
		userNameView = (TextView) findViewById(R.id.tela_chat_tv_nome);
		
		bt_enviar= (Button) findViewById(R.id.tela_chat_bt_enviar);
		bt_enviar.setOnClickListener(click_bt_enviar);
	}
	
	/*
	 * Recebe os dados necessarios de uma classe para ser utilizado no chat 
	 */
	public void RecebeDados()
	{ 
    
		Intent intent = getIntent();
    	
		if(intent != null)
		{
    		Bundle extras = intent.getExtras();
    	
    		if(extras != null)
    		{    			
    			nomeUsuario = extras.getString("Nome");
    			MeuNome = extras.getString("MeuNome");
    			MeuId = extras.getInt("MeuID");
    			UserId = extras.getInt("UserID");
    			tipo = extras.getInt("Tipo");	
    			possui = extras.getInt("New");
    		}
    	}
    	userNameView.setText(nomeUsuario);
    }   
	/* onClick */
	/*
	 * Botao enviar mensagem para usuario, quando o usuario clicar em enviar, sera chamado uma funo para estar enviando essas 
	 * informacoes.
	 */
	OnClickListener click_bt_enviar = new OnClickListener()
	{
		@Override
		public void onClick(View v) 
		{
			final EditText txtEdit = (EditText) findViewById(R.id.tela_chat_edt_mensagem);
			/*
			 * faz a verificao se existe conexao com a internet para que possa estar enviando a mensagem do usuario
			 */
			if (VerificaConexao(Tela_de_chat_do_usuario.this)) 
			{             
				if(txtEdit.getText().toString().equalsIgnoreCase(" ")||txtEdit.getText().toString().equalsIgnoreCase("\n"))
				{
					
				}
				else
				{
					MeuNome = MeuNome.replace("%20"," ");
					msgList.add(MeuNome+": "+txtEdit.getText().toString());
					new Envia_Mensagem_Botao_Chat(MeuId, UserId,ID_Conversa,txtEdit.getText().toString(), MeuNome, nomeUsuario).execute();//envio minha coordenada para o banco de dados
					msgView.smoothScrollToPosition(msgList.getCount() - 1);
				}
				txtEdit.setText("");//limpo o campo onde foi digitado o texto
	        }
			else
			{  
	            ToastMake("Erro: verifique sua conexo com a internet.");
	        } 
		}
	};

	/*
	* faz a verificao automatica no banco de dados para receber novas mensagens apenas do chat 
	*/
	private void Temporizador()
	{
	
		if (VerificaConexao(Tela_de_chat_do_usuario.this)) 
		{             
			VerificaNovasMensagensTelaChat();
			CancelaErro = false;//caso tenha conexao fica com falso ainda
        }
		else 
		{  
        	
			if(CancelaErro == false)
        	{ //caso seja a primeira vez entra no lao
        		ToastMake("Sem conexo com a internet.");
        		CancelaErro = true;//apos entrar no lao mudo o status para nao mostrar outras vezes
        	}
        }  
		
		startTime = SystemClock.uptimeMillis();
		customHandler.postDelayed(updateTimerThread, 0);
	}
	
	private Runnable updateTimerThread = new Runnable()
	{
		
		public void run()
		{	
			timeInMilliseconds = SystemClock.uptimeMillis() - startTime;
			
			updatedTime = timeSwapBuff + timeInMilliseconds;
			int secs = (int) (updatedTime / 1000);
			secs = secs % 60;
		
			customHandler.postDelayed(this, 0);
		
			//tempo para atualizar os dados
			if(secs==15)
			{
				timeSwapBuff += timeInMilliseconds;
				customHandler.removeCallbacks(updateTimerThread);
				startTime = 0L;			
				timeInMilliseconds = 0L;
				timeSwapBuff = 0L;
				updatedTime = 0L;
				Temporizador();
			}
		}
	};
	/*
	 * Cancelo a thread inicializada no temporizador
	 */
	public void CancelMyThread()
	{
		timeSwapBuff += timeInMilliseconds;
		customHandler.removeCallbacks(updateTimerThread);
	}
	
	/*
	 * Crio uma conexao com o usuario da tela, ou seja, crio uma chave que somente vai aparecer mensagens
	 * desse usuario, caso ele ja tenha outras mensagem vai estar aparecendo, primeiramente efetua o download do servidor essas mensagem
	 */
	public void CriaConversa()
	{
		AsyncTask<Void, Void, Void> task = new AsyncTask<Void, Void, Void>()
		{
		    public String Conteudo;
		    String data =""; 
		
		    @Override
			protected Void doInBackground(Void... params) 
		    {
		    	BufferedReader reader = null; 
		    	try
		    	{ 
		    		URL url = new URL("http://www.brunodeandrade.com.br/luciano/conversas.php?id_meu="+MeuId+"&id_usuario="+UserId);
		    		URLConnection conn = url.openConnection(); 
		    		conn.setDoOutput(true); 
		            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream()); 
		            wr.write( data ); 
		            wr.flush(); 
		            //Pego a resposta do servidor 
		            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            StringBuilder sb = new StringBuilder();
		            String line = null;
		            
			        // escrevo a resposta do servidor
			        while((line = reader.readLine()) != null)
			        {
			        	// Acrescento a resposta do servidor em uma string
			            sb.append(line + "\n");
			        }
		            // Acrescento a resposta do servidor no Content string
		            Conteudo = sb.toString();
		    	}
		    	catch(Exception ex)
		    	{
		    		ex.getMessage();
		    	}
		    	finally
		    	{
		    		try
		    		{
		    			reader.close();
		            }
		    		catch(Exception ex) {
		            	
		            }
		    	}
		        return null;
			}
		    
			@Override 
			protected void onPreExecute()
			{ 
				super.onPreExecute(); 
			}
			
			@Override
			protected void onPostExecute(Void result)
			{
				super.onPostExecute(result);
				
				try
				{
					GlobalClass globalVariable = (GlobalClass) getApplicationContext();
					//Cria um novo JSONOBject com nome vindo da JSON string
			        JSONArray jsonResposta = new JSONArray(Conteudo);
					int TamanhoJsonArr = jsonResposta.length();
				
					for(int i = 0; i < TamanhoJsonArr; i++) 
					{
						JSONObject jsonObject = jsonResposta.getJSONObject(i);
						ID_Conversa = jsonObject.getInt("codigo_mensagem");
						globalVariable.setGlobal(ID_Conversa);
					}
			    }
				catch (JSONException e) 
				{
			    	e.printStackTrace();
			    }
			}
		};
		task.execute();
	}
	
	@Override
	public void onResume()
	{
		super.onResume();
	}
	
	@Override
	public void onPause()
	{
		super.onPause();
	}	
	
	@Override
	public void onDestroy()
	{
		super.onDestroy();
		finish();
	}
	
	/*
	 * Verifica novas mensagens APENAS do chat, envio o ID da conversa obtida no procedimento
	 * criaconversa e retorna a mensagem
	 */
	public void VerificaNovasMensagensTelaChat()
	{
		AsyncTask<Void, Void, Void> task = new AsyncTask<Void, Void, Void>()
		{
		    public String Conteudo;
		    String data =""; 
			@Override
			protected Void doInBackground(Void... params) 
			{
		    	BufferedReader reader = null;
		    
		    	try
		    	{ 
		    		// Define a URL que esta enviando os dados
		    		URL url = new URL("http://www.brunodeandrade.com.br/luciano/chat.php?cod_msg="+ID_Conversa+"&meu_id="+MeuId);
		    		URLConnection conn = url.openConnection(); 
		    		conn.setDoOutput(true); 
		            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream()); 
		            wr.write( data ); 
		            wr.flush(); 
		            //Pego a resposta do servidor 
		            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            StringBuilder sb = new StringBuilder();
		            String line = null;
		            
			        // escrevo a resposta do servidor
			        while((line = reader.readLine()) != null)
			        {
			        	// Acrescento a resposta do servidor em uma string
			            sb.append(line + "\n");
			        }
		            // Acrescento a resposta do servidor no Content string
		            Conteudo = sb.toString();
		    	}
		    	catch(Exception ex)
		    	{
		    		ex.getMessage();
		    	}
		    	finally
		    	{
		    		try
		    		{
		    			reader.close();
		            }
		    		catch(Exception ex) {
		            }
		    	}
		        return null;
			}
			
			@Override 
			protected void onPreExecute() 
			{ 
				super.onPreExecute(); 
			}
			
			@Override
			protected void onPostExecute(Void result)
			{
				super.onPostExecute(result); 
				
				try 
				{
					int Remove;
					//Cria um novo JSONOBject com nome vindo da JSON string
			        JSONArray jsonResposta = new JSONArray(Conteudo);
					int TamanhoJsonArr = jsonResposta.length();
					int i, ok = 0;
					
					for(i = 0; i < TamanhoJsonArr; i++) 
					{
						JSONObject jsonObject = jsonResposta.getJSONObject(i);
						Remove = jsonObject.getInt("id_send");
			            
						if(Remove != MeuId)
			            {
			            	MensagemNotificacao = jsonObject.getString("mensagem");
			            	msgList.add(nomeUsuario+": "+MensagemNotificacao);
			            	msgView.smoothScrollToPosition(msgList.getCount() - 1);	
			            	/*efetuo uma vibrao no celular apenas para o 
			            	 *usuario verificar que recebeu uma mensagem do chat
			            	*/
			            	Vibrator v = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
			            	v.vibrate(200);
			            	ok = 1;//mudo para ficar no lao ate receber a mensagem
			            }
					}
					
					if(possui == 1 && i == TamanhoJsonArr)//quando receber a mensagem entra no lao
					{
						if(ok == 1)//caso seja uma nova mensagme ele entra nesse lao finalizando do dialog
						{
							CarregandoMensagensDialog.dismiss();
							possui = 0;
						}
					}
			    }
				catch (JSONException e)
				{
			    	e.printStackTrace();
			    }
			}
		};
		task.execute();
	}
	
	public void ToastMake(String Msg)
    {
		Toast.makeText(this,Msg,Toast.LENGTH_SHORT).show();
	}
    
	@Override
	public boolean onOptionsItemSelected(MenuItem item) 
	{
		int id=item.getItemId();
		
		if(id == R.id.painel_opcoes_sobre)
		{
			VerificaNovasMensagensTelaChat();			
		}
		return super.onOptionsItemSelected(item);
	}
	
	public boolean onCreateOptionsMenu(Menu menu) 
	{
		 // Inflate the menu; this adds items to the action bar if it is present.
		 //getMenuInflater().inflate(R.menu.config_chat, menu);
		 return true;
	}
	
	public void onBackPressed()
	{
		CancelMyThread();
	    finish();	
	
	    if(tipo == 1)
	    {
			Bundle extras = new Bundle();
			extras.putString("MeuNome", MeuNome);
			extras.putInt("MeuID", MeuId);			
			Intent ChamaChat = new Intent(getApplicationContext(),Painel_Mensagens.class);
			ChamaChat.putExtras(extras);//envia o parametro
			startActivity(ChamaChat);
		}
	    else
	    {
		    return;
		}
	}
	
	/* 
	 * Faz a verificaao se o SmartPhone est conectado a internet, caso esteja retorna verdadeiro, o usuario
	 * conseguira ter acesso a informaes do aplicativo, se no houver conexo uma mensagem de erro seja 
	 * apresentado ao usuario informando a falta de conectividade
	 */
	public boolean VerificaConexao(Context classe) 
	{  
        //Pego a conectividade do contexto passado como argumento  
        ConnectivityManager gerenciador = (ConnectivityManager) classe.getSystemService(Context.CONNECTIVITY_SERVICE);  
        //Crio a varivel informacao que recebe as informaes da Rede  
        NetworkInfo informacao = gerenciador.getActiveNetworkInfo();  
        //Se o objeto for nulo ou nao tem conectividade retorna false  
    
        if ((informacao != null) && (informacao.isConnectedOrConnecting()) && (informacao.isAvailable())) 
        {  
        	return true; 
        }  
        return false;  
    }   		    
}